'use strict';

function arrify(value) {
  return Array.isArray(value) ? value : [value];
}

function createEvents(eventDefinitions, prevState, action) {
  return arrify(eventDefinitions).map(function (_ref) {
    var eventFields = _ref.eventFields,
        eventSchema = _ref.eventSchema;

    if (typeof eventFields !== 'function') {
      return null;
    }

    var event = eventFields(action, prevState);

    if (eventSchema !== undefined) {
      var eventPropIsValid = function eventPropIsValid(prop) {
        return eventSchema[prop](event[prop]);
      };
      var isValidEvent = Object.keys(eventSchema).every(eventPropIsValid);
      return isValidEvent ? event : null;
    }

    return event;
  }).filter(function (event) {
    return event !== null;
  });
}

module.exports = createEvents;